#ifndef _HACK_MICROSOFT_H_
#define _HACK_MICROSOFT_H_

#define GL_GLEXT_PROTOTYPES
#include <winsock2.h>
#include <windows.h>
#include <stdint.h>
#include <pthread.h>
#include <GL/gl.h>
#include <GL/glext.h>

int pipe(int [2]);

#define FLOAT FLOAT_MICROSOFT

#define CLOCK_MONOTONIC_RAW 0

#if 0
struct timespec {
    time_t   tv_sec;        /* seconds */
    long     tv_nsec;       /* nanoseconds */
};
#endif

int clock_gettime(int, struct timespec *);

/* X */

typedef int Display;
typedef int Window;
typedef void * GLXContext;
typedef struct { int depth, visual, screen; } XVisualInfo;
typedef struct { int flags, x, y; } XSizeHints;
typedef int Atom;
typedef struct { int width, height, x, y, map_state, root; } XWindowAttributes;
typedef int Cursor;
typedef int Pixmap;
typedef struct { int red, green, blue;} XColor;
typedef struct { int type; int state; int k; } xkey;
typedef union {
  int type;
  struct { int type; int _; } xmap;
  struct { int type; int width, height; } xconfigure;
  struct { int type; int x, y; } xmotion;
  struct { int type; int x, y, button; } xbutton;
  xkey xkey;
  struct { int type; void *display; int window, x, y, width, height; } xexpose;
} XEvent;
typedef int KeySym;
typedef void XErrorEvent;
typedef int Colormap;
typedef struct { int colormap; } XSetWindowAttributes;

#define AllocNone 0
#define CWColormap 0
#define KeyPressMask 0
#define EnterWindowMask 0
#define PointerMotionMask 0
#define StructureNotifyMask 0
#define ExposureMask 0
#define ButtonPressMask 0
#define ButtonReleaseMask 0

#define USPosition 0

#define GLX_RGBA 0
#define GLX_DEPTH_SIZE 0
#define GLX_DOUBLEBUFFER 0
#define None 0
#define True 0
#define False 0
#define IsViewable 0

#define XA_ATOM 0
#define PropModeReplace 0
#define InputOutput 0

#define DefaultRootWindow(x) 0
#define DefaultScreen(x) 0

void XSelectInput(void *, int, int);
void *XOpenDisplay(void *);
XVisualInfo *glXChooseVisual(void *, int, void *);
int XCreateWindow(void *, int, int, int, int, int, int, int, int,
                  int, int, void *);
void XMapWindow(void *, int);

void *glXCreateContext(void *, void *, void *, int);
int glXMakeCurrent(void *, int, void *);
void glXSwapBuffers(void *, int);
void XDestroyWindow(void *, int);
void XSetWMNormalHints(void *, int, void *);
void XMoveWindow(void *, int, int, int);
void XGetWindowAttributes(void *x, int y, XWindowAttributes *wa);
int XInternAtom(void *, void *, int);
void XChangeProperty(void *, ...);
int XCreateBitmapFromData(void *, ...);
int XCreatePixmapCursor(void *, ...);
void XDefineCursor(void *, ...);
void XFreeCursor(void *, int);
void XFreePixmap(void *, int);
void XUndefineCursor(void *, int);
void XNextEvent(void *, XEvent *);
void XWindowEvent(void *, int, int, XEvent *);
void XTranslateCoordinates(void *, ...);
int XPending(void *);
void XLookupString(xkey *, char *, int, KeySym *, void *);
int ConnectionNumber(void *);
void XSendEvent(void *, ...);
void XPutBackEvent(void *, ...);
void XCloseDisplay(void *);
void XFlush(void *);
void XSetErrorHandler(void *);
#define XCreateColormap(...) 0
#define RootWindow(x, y) 0

#define MapNotify 1
#define ConfigureNotify 2
#define Expose 3
#define MotionNotify 4
#define EnterNotify 5
#define ButtonRelease 6
#define ButtonPress 7
#define KeyPress 8
#define NoEvent 9

#define XK_Escape      1000001
#define XK_Up          1000002
#define XK_KP_Up       1000003
#define XK_Down        1000004
#define XK_KP_Down     1000005
#define XK_Prior       1000006
#define XK_KP_Prior    1000007
#define XK_Next        1000008
#define XK_KP_Next     1000009
#define XK_Left        1000010
#define XK_Right       1000011
#define XK_KP_1        1000012
#define XK_KP_End      1000013
#define XK_KP_2        1000014
#define XK_KP_3        1000015
#define XK_KP_4        1000016
#define XK_KP_Left     1000017
#define XK_KP_5        1000018
#define XK_KP_Begin    1000019
#define XK_KP_6        1000020
#define XK_KP_Right    1000021
#define XK_KP_7        1000022
#define XK_KP_Home     1000023
#define XK_KP_8        1000024
#define XK_KP_9        1000025
#define XK_KP_0        1000026
#define XK_KP_Insert   1000027

#define ControlMask 1

/* alsa */

typedef long snd_pcm_sframes_t;
typedef int snd_pcm_t;
typedef struct { int _; } snd_pcm_hw_params_t;
typedef struct { int _; } snd_pcm_sw_params_t;
typedef int snd_pcm_uframes_t;
typedef int snd_pcm_format_t;

#define SND_PCM_FORMAT_S16_LE 0
#define SND_PCM_STREAM_PLAYBACK 0
#define SND_PCM_ACCESS_RW_INTERLEAVED 0
#define ESTRPIPE 0

#define snd_strerror(x) ""

int snd_pcm_open(void *, ...);
void snd_pcm_hw_params_alloca(void *);
void snd_pcm_sw_params_alloca(void *);
int snd_pcm_hw_params_any(void *, ...);
int snd_pcm_hw_params_set_access(void *, ...);
int snd_pcm_hw_params_set_format(void *, ...);
int snd_pcm_hw_params_set_channels(void *, void *, int);
int snd_pcm_hw_params_set_rate_near(void *, void *, unsigned int *, int);
int snd_pcm_hw_params_set_period_size_near(void *, ...);
int snd_pcm_hw_params_set_buffer_size_near(void *, ...);
int snd_pcm_hw_params(void *, ...);
void snd_pcm_prepare(void *);
int snd_pcm_writei(void *, void *, int);
int snd_pcm_resume(void *);
int snd_pcm_delay(void *, snd_pcm_sframes_t *);
int snd_pcm_drop(void *);
int snd_pcm_close(void *);

#include <stdio.h>
#define abort() do { printf("abort at %s:%d\n", __FILE__, __LINE__); exit(0); } while (0)

#define fopen microsoft_fopen
#define main microsoft_main
#define write microsoft_write
#define read microsoft_read

FILE *microsoft_fopen(const char *path, const char *mode);

#define getenv microsoft_getenv
char *microsoft_getenv(char *);

#define select microsoft_select
int microsoft_select(int nfds, fd_set *readfds, fd_set *writefds,
                  fd_set *exceptfds, struct timeval *timeout);

#endif /* _HACK_MICROSOFT_H_ */
