#include <stdio.h>
#include <pthread.h>
#include <winsock2.h>

/* clock_gettime stuff stolen from
 * http://stackoverflow.com/questions/5404277/porting-clock-gettime-to-windows
 */

LARGE_INTEGER
getFILETIMEoffset()
{
    SYSTEMTIME s;
    FILETIME f;
    LARGE_INTEGER t;

    s.wYear = 1970;
    s.wMonth = 1;
    s.wDay = 1;
    s.wHour = 0;
    s.wMinute = 0;
    s.wSecond = 0;
    s.wMilliseconds = 0;
    SystemTimeToFileTime(&s, &f);
    t.QuadPart = f.dwHighDateTime;
    t.QuadPart <<= 32;
    t.QuadPart |= f.dwLowDateTime;
    return (t);
}

int
clock_gettime(int X, struct timespec *tv)
{
    LARGE_INTEGER           t;
    FILETIME            f;
    double                  microseconds;
    static LARGE_INTEGER    offset;
    static double           frequencyToMicroseconds;
    static int              initialized = 0;
    static BOOL             usePerformanceCounter = 0;

    if (!initialized) {
        LARGE_INTEGER performanceFrequency;
        initialized = 1;
        usePerformanceCounter = QueryPerformanceFrequency(&performanceFrequency);
        if (usePerformanceCounter) {
            QueryPerformanceCounter(&offset);
            frequencyToMicroseconds = (double)performanceFrequency.QuadPart / 1000000.;
        } else {
            offset = getFILETIMEoffset();
            frequencyToMicroseconds = 10.;
        }
    }
    if (usePerformanceCounter) QueryPerformanceCounter(&t);
    else {
        GetSystemTimeAsFileTime(&f);
        t.QuadPart = f.dwHighDateTime;
        t.QuadPart <<= 32;
        t.QuadPart |= f.dwLowDateTime;
    }

    t.QuadPart -= offset.QuadPart;
    microseconds = (double)t.QuadPart / frequencyToMicroseconds;
    t.QuadPart = microseconds;
    tv->tv_sec = t.QuadPart / 1000000;
    tv->tv_nsec = (t.QuadPart % 1000000) * 1000;
    return (0);
}
int snd_pcm_drop(void *x) {return 0;}
int snd_pcm_resume(void *x) {return 0;}
void snd_pcm_prepare(void *x) {}
int snd_pcm_open(void *x, ...) {return 0;}
int snd_pcm_hw_params_set_buffer_size_near(void *x, ...) {return 0;}
int snd_pcm_hw_params_set_period_size_near(void *x, ...) {return 0;}
int snd_pcm_hw_params_set_format(void *x, ...) {return 0;}
int snd_pcm_hw_params_set_access(void *x, ...) {return 0;}
int snd_pcm_hw_params_any(void *x, ...) {return 0;}
void snd_pcm_sw_params_alloca(void *x) {}
void snd_pcm_hw_params_alloca(void *x) {}

void XCloseDisplay(void *x) {}
void XFlush(void *x) {}
void XTranslateCoordinates(void *x, ...) {}
void XFreePixmap(void *x, int y) {}
void XFreeCursor(void *x, int y) {}
int XCreatePixmapCursor(void *x, ...) {return 0;}
int XCreateBitmapFromData(void *x, ...) {return 0;}
void XSelectInput(void *x, int y, int z) {}
XVisualInfo*glXChooseVisual(void*x,int y,void*z){static XVisualInfo v;return &v;}
void XMapWindow(void *x, int y) {}
void *glXCreateContext(void *x, void *y, void *z, int a) {return 0;}
int glXMakeCurrent(void *x, int y, void *z) { return 1; }
void XDestroyWindow(void *x, int y) {}
void XSetWMNormalHints(void *x, int y, void *z) {}
void XMoveWindow(void *x, int y, int z, int a) {}
void XChangeProperty(void *x, ...) {}
int XInternAtom(void *x, void *y, int z) {return 0;}
GLAPI void APIENTRY glActiveTexture(GLenum i) {}
void XPutBackEvent(void *x, ...) {}

#undef main

//int main(int n, char **v)
int APIENTRY
WinMain(HINSTANCE hCurrentInst, HINSTANCE hPreviousInst,
        LPSTR lpszCmdLine, int _nCmdShow)
{
  int microsoft_main(int, char **);
  WSADATA WsaDat;
  extern int nCmdShow;
  nCmdShow = _nCmdShow;
  if (WSAStartup(MAKEWORD(2, 2), &WsaDat))
    { fprintf(stderr, "can't init sockets\n"); return 1; }
  if (!pthread_win32_process_attach_np())
    { fprintf(stderr, "can't init threads\n"); return 1; }
  { void microsoft_init_x(); microsoft_init_x(); }
  char *argv[] = { "x", "-v" };
  return microsoft_main(0, argv);
}

int microsoft_read(int fd, void *buf, int count)
{
#if 0
  DWORD ret;
  if (ReadFile((HANDLE)fd, buf, count, &ret, NULL) == 0) abort();
  return ret;
#endif
  if (recv(fd, buf, count, 0) != count) abort();
  return count;
}

int microsoft_write(int fd, void *buf, int count)
{
#if 0
  DWORD ret;
  if (WriteFile((HANDLE)fd, buf, count, &ret, NULL) == 0) {
    DWORD dw= GetLastError();
    LPVOID lpMsgBuf;
    FormatMessage(
        FORMAT_MESSAGE_ALLOCATE_BUFFER | 
        FORMAT_MESSAGE_FROM_SYSTEM |
        FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL,
        dw,
        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
        (LPTSTR) &lpMsgBuf,
        0, NULL );
    printf("WriteFile error %ld: %s\n", dw, (char *)lpMsgBuf);
    LocalFree(lpMsgBuf);
    abort();
  }
  return ret;
#endif
  if (send(fd, buf, count, 0) != count) abort();
  return count;
}

#undef getenv
char *microsoft_getenv(char *x)
{
  if (!strcmp(x, "HOME")) return getenv("USERPROFILE");
  return getenv(x);
}

#undef fopen
FILE *microsoft_fopen(const char *path, const char *mode)
{
  FILE *ret;
  char *z = strdup(path); if (z == NULL) abort();
  char *t = z;
  while (*t) { if (*t == '/') *t = '\\'; t++; }
  ret = fopen(z, mode);
  free(z);
  return ret;
}
