#include "thread.h"
#include <winsock2.h>
#include <pthread.h>

static pthread_mutex_t lock = PTHREAD_MUTEX_INITIALIZER;
#define LOCK do { if (pthread_mutex_lock(&lock)) abort(); } while (0)
#define UNLOCK do { if (pthread_mutex_unlock(&lock)) abort(); } while (0)

int pipe(int p[2])
{
  LOCK;
printf("pipe start\n");
  struct sockaddr_in addr;
  int len;
  SOCKET new;
  SOCKET sock_read = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
  SOCKET sock_write = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
  if (sock_read == INVALID_SOCKET) abort();
  if (sock_write == INVALID_SOCKET) abort();

  addr.sin_family = AF_INET;
  addr.sin_addr.s_addr = inet_addr("127.0.0.1");
  addr.sin_port = 0;
  if (bind(sock_read, (struct sockaddr *)&addr, sizeof(addr))) {
    printf("error %d\n", WSAGetLastError());
    abort();
  }

  if (listen(sock_read, 1)) {
    printf("error %d\n", WSAGetLastError());
    abort();
  }

  len = sizeof(addr);
  if (getsockname(sock_read, (struct sockaddr *)&addr, &len)) abort();

  if (connect(sock_write, (struct sockaddr *)&addr, len)) abort();
  new = accept(sock_read, (struct sockaddr *)&addr, &len);
  if (new == INVALID_SOCKET) abort();

  closesocket(sock_read);

  p[0] = new;
  p[1] = sock_write;

printf("pipe end new %d sock_write %d\n", new, sock_write);
  UNLOCK;
  return 0;
}
