#include <windows.h>
#include <windowsx.h>
#include <string.h>
#include "thread.h"
#undef FLOAT
#include <GL/wglext.h>

static int microsoft_fullscreen;
static int microsoft_cursor_visible;

static XEvent *queue;
static int qsize;
static int qmaxsize;
static int microsoft_mouse_x;
static int microsoft_mouse_y;

static void queue_put(XEvent *ev)
{
printf("queue_put %d\n", ev->type);
  if (qsize == qmaxsize) {
    qmaxsize += 256;
    queue = realloc(queue, qmaxsize * sizeof(XEvent));
    if (queue == NULL) abort();
  }
  queue[qsize] = *ev;
  qsize++;
}

static void queue_get(XEvent *ev)
{
  *ev = *queue;
  qsize--;
  memmove(queue, queue+1, sizeof(XEvent) * qsize);
}

int nCmdShow;

HWND microsoft_window;
volatile int microsoft_window_created;

static HGLRC hRC;                          /* opengl context */
static HDC hDC;
static int xserver_read;
static int xserver_write;

int ConnectionNumber(void *_)
{
  return xserver_read;
}

static XEvent microsoft_event;
static int microsoft_width, microsoft_height;

static LONG WINAPI cb(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  printf("%s:%d: cb called (%d)\n", __FILE__, __LINE__, uMsg);
  microsoft_event.type = NoEvent;
  switch (uMsg) {
  case WM_KILLFOCUS: SetWindowPos(microsoft_window, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE); return 0;
  case WM_ERASEBKGND: return 1;
  case WM_QUIT: exit(0);
  case WM_CLOSE: exit(0);
  case WM_SIZE:
    microsoft_event.type = ConfigureNotify;
    microsoft_event.xconfigure.width = microsoft_width = LOWORD(lParam);
    microsoft_event.xconfigure.height = microsoft_height = HIWORD(lParam);
printf("WM_SIZE event width %d height %d\n", microsoft_width, microsoft_height);
    queue_put(&microsoft_event);
//    microsoft_event.type = Expose;
//    queue_put(&microsoft_event);
    PostMessage(microsoft_window, WM_USER, 0, 0);
    return 0;
  case WM_SYSCOMMAND:
printf("WM_SYSCOMMAND %x\n", wParam);
    if (wParam == SC_SCREENSAVE) return 0;
#if 0
    if (wParam == SC_MONITORPOWER) {
      if (lParam != -1)
        SendMessage(HWND_BROADCAST,WM_SYSCOMMAND,SC_MONITORPOWER,(LPARAM)-1);
      return 0;
    }
#endif
    break;
  case WM_PAINT:
    microsoft_event.type = Expose;
    queue_put(&microsoft_event);
    break;
  case WM_USER:
    microsoft_event.type = Expose;
    queue_put(&microsoft_event);
    return 0;
  case WM_KEYDOWN: {
    printf("key %d (%ld)\n", wParam, lParam);
#define K(x) microsoft_event.type = KeyPress; \
             microsoft_event.xkey.state = 0; \
             microsoft_event.xkey.k = x; \
             queue_put(&microsoft_event); \
             return 0;
    switch (wParam) {
    case 27: K(XK_Escape);
    case 38: K(XK_Up);
    case 40: K(XK_Down);
    case 33: K(XK_Prior);
    case 34: K(XK_Next);
    case 37: K(XK_Left);
    case 39: K(XK_Right);
    case 35: K(XK_KP_End);
    case 12: K(XK_KP_Begin);
    case 36: K(XK_KP_Home);
    case 45: K(XK_KP_Insert);
    }
#undef K
    //return 0;
    break;
  }
  case WM_CHAR:
    if (wParam != 6 && wParam != 13 && wParam >= 1 && wParam <= 26) {
      microsoft_event.type = KeyPress;
      microsoft_event.xkey.state = ControlMask;
      microsoft_event.xkey.k = wParam-1+'a';
      queue_put(&microsoft_event);
      return 0;
    }
    if (/*wParam != 'f' &&*/ wParam != 'F')
    if ((wParam >= 'a' && wParam <= 'z') ||
        (wParam >= 'A' && wParam <= 'Z') ||
        (wParam >= '0' && wParam <= '9') ||
        wParam == ' ') {
      microsoft_event.type = KeyPress;
      microsoft_event.xkey.state = 0;
      microsoft_event.xkey.k = wParam;
      queue_put(&microsoft_event);
      return 0;
    }
    printf("char %d '%c'\n", wParam, wParam);
    //return 0;
    break;
  case WM_MOUSEMOVE:
    microsoft_mouse_x = GET_X_LPARAM(lParam);
    microsoft_mouse_y = GET_Y_LPARAM(lParam);
    microsoft_event.type = MotionNotify;
    microsoft_event.xmotion.x = microsoft_mouse_x;
    microsoft_event.xmotion.y = microsoft_mouse_y;
    queue_put(&microsoft_event);
    return 0;
  case WM_LBUTTONDOWN:
    microsoft_mouse_x = GET_X_LPARAM(lParam);
    microsoft_mouse_y = GET_Y_LPARAM(lParam);
    microsoft_event.type = ButtonPress;
    microsoft_event.xbutton.x = microsoft_mouse_x;
    microsoft_event.xbutton.y = microsoft_mouse_y;
    microsoft_event.xbutton.button = 1;
    queue_put(&microsoft_event);
    return 0;
  case WM_LBUTTONUP:
    microsoft_mouse_x = GET_X_LPARAM(lParam);
    microsoft_mouse_y = GET_Y_LPARAM(lParam);
    microsoft_event.type = ButtonRelease;
    microsoft_event.xbutton.x = microsoft_mouse_x;
    microsoft_event.xbutton.y = microsoft_mouse_y;
    microsoft_event.xbutton.button = 1;
    queue_put(&microsoft_event);
    return 0;
  }
  return DefWindowProc(hWnd, uMsg, wParam, lParam); 
}

#if 0
static void *xserver(void *_)
{
  MSG msg;

printf("xserver id %ld\n", GetCurrentThreadId());
printf("microsoft_window thread id %ld\n", GetWindowThreadProcessId(microsoft_window, NULL));
  if (!AttachThreadInput(GetWindowThreadProcessId(microsoft_window, NULL),
                         GetCurrentThreadId(), TRUE)) abort();
//  if (!AttachThreadInput( GetCurrentThreadId(),
//GetWindowThreadProcessId(microsoft_window, NULL),
// TRUE)) abort();

  while (GetMessage(&msg, microsoft_window, 0, 0) > 0) {
printf("xserver got a message\n");
        TranslateMessage(&msg);
        DispatchMessage(&msg);
  }
printf("xserver byebye\n");
  return NULL;
}
#endif

void set_vsync(int interval){
#ifdef WIN32
typedef int bool;
typedef bool (*func)(int);
typedef char* (*wglext)();
func wglSwapIntervalEXT=NULL;
wglext wglGetExtensionsString=NULL;
if((wglGetExtensionsString = (wglext)wglGetProcAddress("wglGetExtensionsString")) &&
strstr( (char*)wglGetExtensionsString(), "WGL_EXT_swap_control") == 0) {
if(wglGetExtensionsString==NULL){
printf ("Does not support wglGetExtensionsString\n");
abort();
} else{
printf ("Does not support WGL_EXT_swap_control\n");
printf ("%s\n",(char*)wglGetExtensionsString());
abort();
}
return;
}else {
wglSwapIntervalEXT = (func)wglGetProcAddress("wglSwapIntervalEXT");
if( wglSwapIntervalEXT ) {
int ret = wglSwapIntervalEXT(interval); if (ret == 0) abort();
printf ("Changed invertal:%d\n",interval);
}else{
printf ("Does not find wglSwapIntervalEXT\n");
abort();
}
}
#endif
}

static WINDOWPLACEMENT g_wpPrev = { sizeof(g_wpPrev) };
static void toggle_fullscreen(void)
{
  DWORD dwStyle = GetWindowLong(microsoft_window, GWL_STYLE);
  if (dwStyle & WS_OVERLAPPEDWINDOW) {
    MONITORINFO mi = { sizeof(mi) };
    if (GetWindowPlacement(microsoft_window, &g_wpPrev) &&
        GetMonitorInfo(MonitorFromWindow(microsoft_window,
                       MONITOR_DEFAULTTOPRIMARY), &mi)) {
      SetWindowLong(microsoft_window, GWL_STYLE,
                    dwStyle & ~WS_OVERLAPPEDWINDOW);
      SetWindowPos(microsoft_window, HWND_TOP,
                   mi.rcMonitor.left, mi.rcMonitor.top,
                   mi.rcMonitor.right - mi.rcMonitor.left,
                   mi.rcMonitor.bottom - mi.rcMonitor.top,
                   SWP_NOOWNERZORDER | SWP_FRAMECHANGED);
      microsoft_fullscreen = 1;
    }
  } else {
    SetWindowLong(microsoft_window, GWL_STYLE,
                  dwStyle | WS_OVERLAPPEDWINDOW);
    SetWindowPlacement(microsoft_window, &g_wpPrev);
    SetWindowPos(microsoft_window, NULL, 0, 0, 0, 0,
                 SWP_NOMOVE | SWP_NOSIZE | SWP_NOZORDER |
                 SWP_NOOWNERZORDER | SWP_FRAMECHANGED);
    microsoft_fullscreen = 0;
    if (microsoft_cursor_visible == 0) {
      microsoft_cursor_visible = 1;
      ShowCursor(1);
    }
  }
}

int XCreateWindow(void *x, int y, int z, int a, int width, int height,
                  int d, int e, int f, int g, int h, void *i)
{
printf("XCreateWindow id %ld\n",GetCurrentThreadId());

  static int first_run = 1;
  if (!first_run) {
    toggle_fullscreen();
    return 0;
  }
  first_run = 0;

if (!SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_HIGHEST)) abort();
  static HINSTANCE hInstance = 0;
  WNDCLASS wc;
  int pf;
  PIXELFORMATDESCRIPTOR pfd;

  if (!hInstance) {
    hInstance = GetModuleHandle(NULL);
    wc.style         = CS_OWNDC;
    wc.lpfnWndProc   = cb;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hInstance     = 0;
    wc.hIcon         = LoadIcon(NULL, IDI_WINLOGO);
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = NULL;
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = "OpenGL";
    if (!RegisterClass(&wc)) {
      MessageBox(NULL, "RegisterClass() failed:  "
                 "Cannot register window class.", "Error", MB_OK);
      exit(0);
    }
  }

#if 1
  RECT rt = { 0, 0, width, height };
  AdjustWindowRect(&rt, WS_OVERLAPPEDWINDOW, FALSE);
  microsoft_window = CreateWindow("OpenGL", "orangetv",
/**/
 WS_OVERLAPPEDWINDOW |
                      WS_CLIPSIBLINGS | WS_CLIPCHILDREN,
/*
  WS_MAXIMIZE,
*/
                      0, 0, rt.right-rt.left, rt.bottom-rt.top,
                      NULL, NULL, hInstance, NULL);
#endif
#if 0
 /* from http://blogs.msdn.com/b/oldnewthing/archive/2005/05/05/414910.aspx */
 HMONITOR hmon = MonitorFromWindow(NULL,
                                   MONITOR_DEFAULTTONEAREST);
 MONITORINFO mi = { sizeof(mi) };
 if (!GetMonitorInfo(hmon, &mi)) abort();
 microsoft_window = CreateWindow("OpenGL", "orangetv",
       WS_POPUP | WS_VISIBLE |
       WS_CLIPSIBLINGS | WS_CLIPCHILDREN,
       mi.rcMonitor.left,
       mi.rcMonitor.top,
       mi.rcMonitor.right - mi.rcMonitor.left,
       mi.rcMonitor.bottom - mi.rcMonitor.top,
       NULL, NULL, hInstance, NULL);
#endif
#if 0
 HMONITOR hmon = MonitorFromWindow(NULL,
                                   MONITOR_DEFAULTTONEAREST);
 MONITORINFO mi = { sizeof(mi) };
 if (!GetMonitorInfo(hmon, &mi)) abort();
 microsoft_window = CreateWindowEx(WS_EX_APPWINDOW, "OpenGL", "orangetv",
       WS_POPUP | WS_VISIBLE |
       WS_CLIPSIBLINGS | WS_CLIPCHILDREN,
       mi.rcMonitor.left,
       mi.rcMonitor.top,
       mi.rcMonitor.right - mi.rcMonitor.left,
       mi.rcMonitor.bottom - mi.rcMonitor.top,
       NULL, NULL, hInstance, NULL);
#endif
#if 0
 HMONITOR hmon = MonitorFromWindow(NULL,
                                   MONITOR_DEFAULTTONEAREST);
 MONITORINFO mi = { sizeof(mi) };
 if (!GetMonitorInfo(hmon, &mi)) abort();
printf("%ld %ld %ld %ld\n", mi.rcMonitor.left, mi.rcMonitor.top, mi.rcMonitor.right, mi.rcMonitor.bottom);
  //RECT rt = { mi.rcMonitor.left, mi.rcMonitor.top, mi.rcMonitor.right, mi.rcMonitor.bottom };
  RECT rt = { 0, 0, 10, 10 };
  AdjustWindowRect(&rt, /*WS_MAXIMIZE |*/ WS_OVERLAPPEDWINDOW, FALSE);
printf("%ld %ld %ld %ld\n", rt.left, rt.top, rt.right, rt.bottom);
 microsoft_window = CreateWindow("OpenGL", "orangetv",
       //WS_POPUP | WS_VISIBLE |
       /*WS_MAXIMIZE |*/ WS_VISIBLE | WS_OVERLAPPED /*WINDOW*/ |
       0,//WS_CLIPSIBLINGS | WS_CLIPCHILDREN,
                      //0, 0, rt.right-rt.left, rt.bottom-rt.top,
                      0, 0, 2000, 2000,
       //mi.rcMonitor.left,
       //mi.rcMonitor.top,
       //mi.rcMonitor.right - mi.rcMonitor.left,
       //mi.rcMonitor.bottom - mi.rcMonitor.top,
       NULL, NULL, hInstance, NULL);
#endif
  /* from http://stackoverflow.com/questions/2656531/tearing-in-opengl */
  //SetWindowLong(microsoft_window, GWL_STYLE, 0);
  /* does not seem to work, so let's go openGL (does not work either for me,
   * symbol wglSwapIntervalEXT not found blabla) */
  /* ah, fuck it... if you read this (are you sane?) and know how to, get in
   * touch. Sometimes it works, sometimes it does not. I also have very
   * weird alt+tab behavior
   */
  //set_vsync(1);

  microsoft_window_created = 1;

  if (microsoft_window == NULL) {
    MessageBox(NULL, "CreateWindow() failed:  Cannot create a window.",
               "Error", MB_OK);
    exit(0);
 }

    hDC = GetDC(microsoft_window);

    memset(&pfd, 0, sizeof(pfd));
    pfd.nSize        = sizeof(pfd);
    pfd.nVersion     = 1;
    pfd.dwFlags      = PFD_DOUBLEBUFFER | PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL;
    pfd.iPixelType   = PFD_TYPE_RGBA;
    pfd.cColorBits   = 32;
    pfd.iLayerType   = PFD_MAIN_PLANE;

    pf = ChoosePixelFormat(hDC, &pfd);
    if (pf == 0) {
        MessageBox(NULL, "ChoosePixelFormat() failed:  "
                   "Cannot find a suitable pixel format.", "Error", MB_OK); 
        exit(0);
    } 
 
    if (SetPixelFormat(hDC, pf, &pfd) == FALSE) {
        MessageBox(NULL, "SetPixelFormat() failed:  "
                   "Cannot set format specified.", "Error", MB_OK);
        exit(0);
    } 

    DescribePixelFormat(hDC, pf, sizeof(PIXELFORMATDESCRIPTOR), &pfd);

  ShowWindow(microsoft_window, nCmdShow);

    //ReleaseDC(microsoft_window, hDC);

    //hDC = GetDC(microsoft_window);
    hRC = wglCreateContext(hDC);
printf("hRC %p\n", hRC);
    if (!wglMakeCurrent(hDC, hRC)) abort();

//  new_thread(xserver, 0);

//SetWindowLong(microsoft_window, GWL_STYLE, 0);
set_vsync(1);
//exit(0);

  return 0;
}

void *XOpenDisplay(void *x)
{
  return (void *)1;
}

void microsoft_init_x(void)
{
  int p[2];
  if (pipe(p)) abort();
  xserver_read = p[0];
  xserver_write = p[1];
  microsoft_cursor_visible = 1;
}

void glXSwapBuffers(void *x, int y)
{
//  static PAINTSTRUCT ps;
wglSwapLayerBuffers(hDC, WGL_SWAP_MAIN_PLANE);

//printf("swap\n");
//  SwapBuffers(hDC);
  //      BeginPaint(microsoft_window, &ps);
  //     EndPaint(microsoft_window, &ps);
  SetThreadExecutionState(ES_DISPLAY_REQUIRED);
}

int XPending(void *a)
{
  MSG msg;
  if (qsize) return 1;
//printf("calling PeekMessage\n");
  int ret = PeekMessage(&msg, microsoft_window, 0, 0, PM_NOREMOVE);
//printf("PeekMessage call done\n");
//  printf("XPending returns %d\n", ret);
  return ret || qsize;
}

void XWindowEvent(void *x, int w, int mask, XEvent *ev)
{
  /* used only in map_window_and_wait */
  ev->type = Expose;
}

void XNextEvent(void *x, XEvent *ev)
{
  MSG msg;
  if (qsize) { queue_get(ev); return; }
//printf("XNextEvent enter\n");
printf("calling GetMessage\n");
  if (GetMessage(&msg, microsoft_window, 0, 0) > 0) {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
  else exit(0);
printf("GetMessage call done\n");
  if (qsize) { queue_get(ev); return; }
  ev->type = NoEvent;
//printf("microsoft_event type %d\n", microsoft_event.type);
//printf("XNextEvent leave\n");
}

void XSendEvent(void *x, ...)
{
  PostMessage(microsoft_window, WM_USER, 0, 0);
}

#undef select

int microsoft_select(int nfds, fd_set *readfds, fd_set *writefds,
                  fd_set *exceptfds, struct timeval *timeout)
{
  struct timeval t;
  if (FD_ISSET(xserver_read, readfds) && timeout == NULL) {
    t.tv_sec = 0;
    t.tv_usec = 40 * 1000;
    timeout = &t;
  }
  if (FD_ISSET(xserver_read, readfds)) {
    //set_vsync(1);
    glFinish();
    GdiFlush();
  }
  return select(nfds, readfds, writefds, exceptfds, timeout);
}

void XLookupString(xkey *xkey, char *_, int __, KeySym *ks, void *___)
{
  *ks = xkey->k;
}

void XGetWindowAttributes(void *x, int y, XWindowAttributes *wa)
{
  wa->width = microsoft_width;
  wa->height = microsoft_height;
  wa->x = wa->y = 0;
  wa->map_state = IsViewable;
  wa->root = 0;
}

void XUndefineCursor(void *x, int y)
{
  if (microsoft_fullscreen) {
    if (microsoft_cursor_visible == 0) ShowCursor(1);
    microsoft_cursor_visible = 1;
  }
  else if (microsoft_cursor_visible == 0) {
    ShowCursor(1);
    microsoft_cursor_visible = 1;
  }
}

void XDefineCursor(void *x, ...)
{
  if (microsoft_fullscreen) {
    if (microsoft_cursor_visible == 1) ShowCursor(0);
    microsoft_cursor_visible = 0;
  }
  else if (microsoft_cursor_visible == 0) {
    ShowCursor(1);
    microsoft_cursor_visible = 1;
  }
}

void XSetErrorHandler(void *x)
{
}
