#ifndef _XML_H_
#define _XML_H_

typedef struct {
  char *video_url;
  char *audio_url;
  char *video_priv;
  char *audio_priv;
  uint64_t video_start;
  uint64_t audio_start;
  uint64_t video_bitrate;
  int      width;
  uint64_t audio_bitrate;
  uint64_t video_inc;
  uint64_t audio_inc;
  uint64_t video_timescale;
  uint64_t audio_timescale;
  int smooth_streaming_media_count;
  int stream_index_video_count;
  int stream_index_audio_count;
  uint64_t *video_times;
  int video_times_size;
  int video_times_start;
  uint64_t *audio_times;
  int audio_times_size;
  int audio_times_start;
} xmldata;

void init_xml(void);
int parse_xml(xmldata *, char *, int, int);
int try_parse_xml(char *, int);

#endif /* _XML_H_ */
